'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib plans service',function(){const a=function(b){return{target:{responseText:JSON.stringify(b)}}};it('exists',function(){const c=new window.jujulib.plans('http://1.2.3.4/',{});assert.strictEqual(c instanceof window.jujulib.plans,!0),assert.strictEqual(c.url,'http://1.2.3.4/'+window.jujulib.plansAPIVersion)}),it('is smart enough to handle missing trailing slash in URL',function(){const c=new window.jujulib.plans('http://1.2.3.4',{});assert.strictEqual(c.url,'http://1.2.3.4/'+window.jujulib.plansAPIVersion)}),it('lists plans for a charm',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/charm?charm-url=cs:juju-gui-42');const h=a([{url:'canonical-landscape/24-7',plan:'1','created-on':'2016-06-09T22:07:24Z',description:'Delivers the highest level of support.',price:'the/price'},{url:'canonical-landscape/8-5',plan:'B','created-on':'2016-06-09T22:07:24Z',description:'Offers a high level of support.',price:'the/price'},{url:'canonical-landscape/free',plan:'9 from outer space','created-on':'2015-06-09T22:07:24Z',description:'No support available.',price:'Free'}]);g(null,h)}});d.listPlansForCharm('cs:juju-gui-42',function(e,f){assert.isNull(e),assert.deepEqual(f,[{url:'canonical-landscape/24-7',yaml:'1',createdAt:new Date(1465510044000),description:'Delivers the highest level of support.',price:'the/price'},{url:'canonical-landscape/8-5',yaml:'B',createdAt:new Date(1465510044000),description:'Offers a high level of support.',price:'the/price'},{url:'canonical-landscape/free',yaml:'9 from outer space',createdAt:new Date(1433887644000),description:'No support available.',price:'Free'}]),b()})}),it('adds the charm schema prefix when listing plans',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/charm?charm-url=cs:django');const h=a([]);g(null,h)}});d.listPlansForCharm('django',function(e){assert.isNull(e),b()})}),it('handles missing plans',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){const h=a([]);g(null,h)}});d.listPlansForCharm('cs:juju-gui/42',function(e,f){assert.isNull(e),assert.deepEqual(f,[]),b()})}),it('handles errors listing plans',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){const h=a({error:'bad wolf'});g(null,h)}});d.listPlansForCharm('django',function(e,f){assert.equal(e,'bad wolf'),assert.isNull(f),b()})}),it('retrieves the active plan for a given model and app',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/plan/model/uuid/service/app-name');const h=a({'current-plan':'canonical-landscape/free','available-plans':{'canonical-landscape/8-5':{url:'canonical-landscape/8-5',plan:'B','created-on':'2016-06-09T22:07:24Z',description:'Offers a high level of support.',price:'the/price'},'canonical-landscape/free':{url:'canonical-landscape/free',plan:'9 from outer space','created-on':'2015-06-09T22:07:24Z',description:'No support available.',price:'Free'}}});g(null,h)}});d.showActivePlan('uuid','app-name',function(e,f,g){assert.isNull(e),assert.deepEqual(f,{url:'canonical-landscape/free',yaml:'9 from outer space',createdAt:new Date(1433887644000),description:'No support available.',price:'Free'}),assert.deepEqual(g,[{url:'canonical-landscape/8-5',yaml:'B',createdAt:new Date(1465510044000),description:'Offers a high level of support.',price:'the/price'},{url:'canonical-landscape/free',yaml:'9 from outer space',createdAt:new Date(1433887644000),description:'No support available.',price:'Free'}]),b()})}),it('does not request active plans if no modelUUID is provided',function(){const c=new window.jujulib.plans('http://1.2.3.4/',{get:function(){assert.fail('request should not have been made')}});c.showActivePlan(void 0,'app-name',()=>{})}),it('handles errors retrieving the currently active plan',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){const h=a({error:'bad wolf'});g(null,h)}});d.showActivePlan('uuid','app-name',function(e,f,g){assert.equal(e,'bad wolf'),assert.isNull(f),assert.deepEqual(g,[]),b()})}),it('handles authorizing a plan',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{post:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/plan/authorize');const i=a({'look ma':'I\'m a macaroon',params:g});h(null,i)}});d.authorizePlan('envUUID','charmUrl','applicationName','planUrl','budget','limit',function(e,f){assert.isNull(e),assert.equal(f['look ma'],'I\'m a macaroon'),assert.equal(f.params,'{"env-uuid":"envUUID","charm-url":"charmUrl","service-name":"applicationName","plan-url":"planUrl","budget":"budget","limit":"limit"}'),b()})}),it('lists budgets',function(b){const c={budgets:[{owner:'spinach',budget:'my-budget',limit:99,allocated:77,unallocated:22,available:22,consumed:55}],total:{limit:999,allocated:777,unallocated:222,consumed:55,available:22}},e=new window.jujulib.plans('http://1.2.3.4/',{get:function(f,g,h){assert.equal(f,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget');const i=a(c);h(null,i)}});e.listBudgets(function(f,g){assert.isNull(f),assert.deepEqual(g,c),b()})}),it('handles errors listing budgets',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){const h=a({error:'bad wolf'});g(null,h)}});d.listBudgets(function(e,f){assert.equal(e,'bad wolf'),assert.isNull(f),b()})}),it('handles adding a budget',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{post:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget');const i=a({auth:'I\'m a macaroon',params:g});h(null,i)}});d.createBudget('budget','limit',function(e,f){assert.isNull(e),assert.equal(f.auth,'I\'m a macaroon'),assert.equal(f.params,'{"budget":"budget","limit":"limit"}'),b()})}),it('handles errors when adding a budget',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{post:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget');const i=a({error:'bad wolf'});h(null,i)}});d.createBudget('budget','limit',function(e){assert.equal(e,'bad wolf'),b()})}),it('requests to update a budget',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{patch:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/budgetid'),assert.equal(g,'{"limit":"limit"}');const i=a({data:'data'});h(null,i)}});d.updateBudget('budgetid','limit',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('requests to remove a budget',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{delete:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/budgetid');const i=a({data:'data'});h(null,i)}});d.removeBudget('budgetid',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('requests to create an allocation',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{post:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/budgetid/allocation'),assert.deepEqual(g,'{"services":["application"],"model":"model","limit":"limit"}');const i=a({data:'data'});h(null,i)}});d.createAllocation('budgetid','application','model','limit',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('requests to update allocations',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{patch:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/model/model/service/application/allocation'),assert.deepEqual(g,'{"limit":"limit"}');const i=a({data:'data'});h(null,i)}});d.updateAllocation('model','application','limit',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('requests to remove allocations',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{delete:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/environment/model/service/application/allocation');const i=a({data:'data'});h(null,i)}});d.removeAllocation('application','model',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('requests to update credit limits',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{patch:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile/user'),assert.deepEqual(g,'{"update":{"limit":"limit"}}');const i=a({data:'data'});h(null,i)}});d.updateCreditLimit('user','limit',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('requests to update default budget',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{patch:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile'),assert.deepEqual(g,'{"update":{"default-budget":"defaultBudget"}}');const i=a({data:'data'});h(null,i)}});d.updateDefaultBudget('defaultBudget',function(e,f){assert.strictEqual(e,null),assert.deepEqual(f,{data:'data'}),b()})}),it('gets budget details',function(b){const c={limit:'budget limit',total:{allocated:'total allocated amount',available:'unconsumed amount',unallocated:'unallocated amount',usage:'percentage of budget consumed',consumed:'total consumed amount'},allocations:[{owner:'user, creator of allocation',consumed:'amount consumed',limit:'allocation limit',usage:'consumed/limit',model:'model uuid',services:{'service name':{consumed:'consumed',usage:'consumed/allocation limit'}}}]},e=new window.jujulib.plans('http://1.2.3.4/',{get:function(f,g,h){assert.equal(f,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/budget/my-budget');const i=a(c);h(null,i)}});e.showBudget('my-budget',function(f,g){assert.isNull(f),assert.deepEqual(g,c),b()})}),it('handles errors listing budgets',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){const h=a({error:'bad wolf'});g(null,h)}});d.showBudget('my-budget',function(e,f){assert.equal(e,'bad wolf'),assert.isNull(f),b()})}),it('handles adding a profile',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{post:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile');const i=a({auth:'I\'m a macaroon',response:'profile saved'});h(null,i)}});d.createProfile('user','limit','default-budget','default-budget-limit',function(e,f){assert.isNull(e),assert.equal(f.auth,'I\'m a macaroon'),assert.equal(f.response,'profile saved'),b()})}),it('handles errors when adding a budget',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{post:function(e,f,g,h){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/profile');const i=a({error:'bad wolf'});h(null,i)}});d.createProfile('user','limit','default-budget','default-budget-limit',function(e){assert.equal(e,'bad wolf'),b()})}),it('gets kpi metrics for a charm',function(b){const d=new window.jujulib.plans('http://1.2.3.4/',{get:function(e,f,g){assert.equal(e,'http://1.2.3.4/'+window.jujulib.plansAPIVersion+'/kpimetrics?charm-url=cs%3Ajuju-gui-42');const h=a([{Metric:'metric',Time:'t',Sum:42,Count:5,Min:'min',Max:'max'},{Metric:'bad-wolf',Time:'t',Sum:53,Count:8,Min:'min',Max:'max'},{Metric:'metric',Time:'t',Sum:80,Count:10,Min:'min',Max:'max'}]);g(null,h)}});d.getKpiMetrics('cs:juju-gui-42',{},function(e,f){assert.isNull(e),assert.deepEqual(f,[{metric:'metric',time:'t',sum:42,count:5,min:'min',max:'max'},{metric:'bad-wolf',time:'t',sum:53,count:8,min:'min',max:'max'},{metric:'metric',time:'t',sum:80,count:10,min:'min',max:'max'}]),b()})})});