'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('jujulib terms service',function(){let a=[];const b=function(c){return{target:{responseText:JSON.stringify(c)}}};afterEach(function(){a.forEach((c)=>{c()})}),it('exists',function(){const d=new window.jujulib.terms('http://1.2.3.4/',{});assert.strictEqual(d instanceof window.jujulib.terms,!0),assert.strictEqual(d.url,'http://1.2.3.4/'+window.jujulib.termsAPIVersion)}),it('is smart enough to handle missing trailing slash in URL',function(){const d=new window.jujulib.terms('http://1.2.3.4',{});assert.strictEqual(d.url,'http://1.2.3.4/'+window.jujulib.termsAPIVersion)}),it('shows terms with revision',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){assert.equal(f,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/terms/canonical?revision=42');const i=b([{name:'canonical',owner:'spinach',title:'canonical terms',revision:42,'created-on':'2016-06-09T22:07:24Z',content:'Terms and conditions'}]);h(null,i)}});e.showTerms('canonical',42,function(f,g){assert.strictEqual(f,null),assert.deepEqual(g,{name:'canonical',owner:'spinach',title:'canonical terms',revision:42,createdAt:new Date(1465510044000),content:'Terms and conditions'}),c()})}),it('shows most recent terms',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){assert.equal(f,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/terms/canonical');const i=b([{name:'canonical',owner:'spinach',title:'canonical recent terms',revision:47,'created-on':'2016-06-09T22:07:24Z',content:'Terms and conditions'}]);h(null,i)}});e.showTerms('canonical',null,function(f,g){assert.strictEqual(f,null),assert.deepEqual(g,{name:'canonical',owner:'spinach',title:'canonical recent terms',revision:47,createdAt:new Date(1465510044000),content:'Terms and conditions'}),c()})}),it('handles missing terms',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){const i=b([]);h(null,i)}});e.showTerms('canonical',null,function(f,g){assert.strictEqual(f,null),assert.strictEqual(g,null),c()})}),it('handles errors fetching terms',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){const i=b({error:'bad wolf'});h(null,i)}});e.showTerms('canonical',null,function(f,g){assert.equal(f,'bad wolf'),assert.strictEqual(g,null),c()})}),it('handles adding an agreement',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{post:function(f,g,h,i){assert.equal(f,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement');const j=b({agreements:[{user:'spinach',term:'these-terms',revision:42,'created-on':'2016-06-09T22:07:24Z'}]});i(null,j)}});e.addAgreement([{name:'canonical',revision:5}],function(f,g){assert.equal(f,null),assert.deepEqual(g,[{owner:null,user:'spinach',term:'these-terms',revision:42,createdAt:new Date(1465510044000),name:void 0,owner:void 0,content:void 0}]),c()})}),it('passes the agreements request the correct args',function(){const c={post:sinon.stub()},d=new window.jujulib.terms('http://1.2.3.4/',c);d.addAgreement([{name:'canonical',owner:'spinach',revision:5}]),assert.equal(c.post.callCount,1),assert.equal(c.post.args[0][2],'[{"termname":"canonical","termrevision":5,"termowner":"spinach"}]')}),it('can get agreements for a user',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){assert.equal(f,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreements');const i=b([{user:'spinach',term:'One fancy term',revision:47,'created-on':'2016-06-09T22:07:24Z'}]);h(null,i)}});e.getAgreements(function(f,g){assert.strictEqual(f,null),assert.deepEqual(g,[{owner:void 0,user:'spinach',term:'One fancy term',revision:47,createdAt:new Date(1465510044000),name:void 0,owner:void 0,content:void 0}]),c()})}),it('handles missing agreements',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){var i=b([]);h(null,i)}});e.getAgreements(function(f,g){assert.strictEqual(f,null),assert.strictEqual(g,null),c()})}),it('handles errors fetching agreements',function(c){const e=new window.jujulib.terms('http://1.2.3.4/',{get:function(f,g,h){const i=b({Message:'bad wolf'});h(null,i)}});e.getAgreements(function(f,g){assert.equal(f,'bad wolf'),assert.strictEqual(g,null),c()})}),describe('getAgreementsByTerms',()=>{it('makes a proper request with a single term supplied',(c)=>{const e=new window.jujulib.terms('http://1.2.3.4/',{get:(f,g,h)=>{assert.equal(f,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement?Terms=hatch/test-term1'),h(null,b([{'created-on':'2016-06-09T22:07:24Z',content:'I am term1\n',id:'hatch/test-term1',name:'test-term1',owner:'hatch',published:!0,revision:2}]))}});e.getAgreementsByTerms(['hatch/test-term1'],(f,g)=>{assert.strictEqual(f,null),assert.deepEqual(g,[{content:'I am term1\n',createdAt:new Date(1465510044000),name:'test-term1',owner:'hatch',revision:2,term:void 0,user:void 0}]),c()})}),it('makes a proper request with multiple terms supplied',(c)=>{const e=new window.jujulib.terms('http://1.2.3.4/',{get:(f,g,h)=>{assert.equal(f,'http://1.2.3.4/'+window.jujulib.termsAPIVersion+'/agreement?Terms=hatch/test-term1&Terms=hatch/test-term2'),h(null,b([{'created-on':'2016-06-09T22:07:24Z',content:'I am term1\n',name:'test-term1',owner:'hatch',published:!0,revision:2}]))}});e.getAgreementsByTerms(['hatch/test-term1','hatch/test-term2'],(f,g)=>{assert.strictEqual(f,null),assert.deepEqual(g,[{content:'I am term1\n',createdAt:new Date(1465510044000),name:'test-term1',owner:'hatch',revision:2,term:void 0,user:void 0}]),c()})}),it('handles failures fetching agreements',(c)=>{const e=new window.jujulib.terms('http://1.2.3.4/',{get:(f,g,h)=>{h(null,b({Message:'it broke'}))}});e.getAgreementsByTerms(['user/termname'],(f,g)=>{assert.equal(f,'it broke'),assert.strictEqual(g,null),c()})})})});